Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.22
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.jce.provider
Class JCEECDHKeyAgreement

    java.lang.Object
      |
      +--javax.crypto.KeyAgreementSpi
            |
            +--org.bouncycastle.jce.provider.JCEECDHKeyAgreement

Direct Known Subclasses:
  JCEECDHKeyAgreement.DH, JCEECDHKeyAgreement.DHC

public class JCEECDHKeyAgreement
extends javax.crypto.KeyAgreementSpi

Diffie-Hellman key agreement using elliptic curve keys, ala IEEE P1363 both the simple one, and the simple one with cofactors are supported.

Nested Class Summary
`static class` | `JCEECDHKeyAgreement.DH`
`static class` | `JCEECDHKeyAgreement.DHC`

Constructor Summary
`protected` | `JCEECDHKeyAgreement(BasicAgreement agreement)`

Method Summary
`protected java.security.Key` | `engineDoPhase(java.security.Key key, boolean lastPhase)`
`protected byte[]` | `engineGenerateSecret()`
`protected int` | `engineGenerateSecret(byte[] sharedSecret, int offset)`
`protected javax.crypto.SecretKey` | `engineGenerateSecret(java.lang.String algorithm)`
`protected void` | `engineInit(java.security.Key key, java.security.spec.AlgorithmParameterSpec params, java.security.SecureRandom random)`
`protected void` | `engineInit(java.security.Key key, java.security.SecureRandom random)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JCEECDHKeyAgreement

    protected JCEECDHKeyAgreement(BasicAgreement agreement)

Method Detail

### engineDoPhase

    protected java.security.Key engineDoPhase(java.security.Key key,
                                              boolean lastPhase)
                                       throws java.security.InvalidKeyException,
                                              java.lang.IllegalStateException

  Specified by:
    `engineDoPhase` in class `javax.crypto.KeyAgreementSpi`
    `java.security.InvalidKeyException`
    `java.lang.IllegalStateException`

### engineGenerateSecret

    protected byte[] engineGenerateSecret()
                                   throws java.lang.IllegalStateException

  Specified by:
    `engineGenerateSecret` in class `javax.crypto.KeyAgreementSpi`
    `java.lang.IllegalStateException`

### engineGenerateSecret

    protected int engineGenerateSecret(byte[] sharedSecret,
                                       int offset)
                                throws java.lang.IllegalStateException,
                                       javax.crypto.ShortBufferException

  Specified by:
    `engineGenerateSecret` in class `javax.crypto.KeyAgreementSpi`
    `java.lang.IllegalStateException`
    `javax.crypto.ShortBufferException`

### engineGenerateSecret

    protected javax.crypto.SecretKey engineGenerateSecret(java.lang.String algorithm)

  Specified by:
    `engineGenerateSecret` in class `javax.crypto.KeyAgreementSpi`

### engineInit

    protected void engineInit(java.security.Key key,
                              java.security.spec.AlgorithmParameterSpec params,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException,
                              java.security.InvalidAlgorithmParameterException

  Specified by:
    `engineInit` in class `javax.crypto.KeyAgreementSpi`
    `java.security.InvalidKeyException`
    `java.security.InvalidAlgorithmParameterException`

### engineInit

    protected void engineInit(java.security.Key key,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException

  Specified by:
    `engineInit` in class `javax.crypto.KeyAgreementSpi`
    `java.security.InvalidKeyException`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.22
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD